Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1688353 - [glance] transparent image conversion fails
Summary: [glance] transparent image conversion fails
Keywords:
Status: NEW
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-glance
Version: 14.0 (Rocky)
Hardware: x86_64
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Cyril Roelandt
QA Contact: Mike Abrams
Tana
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-13 15:22 UTC by Mauro Oddi
Modified: 2019-03-28 04:37 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Launchpad 1805765 None None None 2019-03-13 15:22:07 UTC

Description Mauro Oddi 2019-03-13 15:22:08 UTC
Description of problem:

RHOSP 14 has been configured to trigger automatic image conversion from qcow2 to raw on image import. But the taskflow triggered fails to run in Conver_Image task as per api.log: 


2019-03-01 23:43:38.658 26 WARNING glance.async.taskflow_executor [-] Task 'api_image_import-Convert_Image-20d240b2-7736-4248-aed7-687fc663b838' (c9b34240-4333-4625-9468-0bf3975d6753) transitioned into state 'FAILURE' from state 'RUNNING'
5 predecessors (most recent first):
  Flow 'api_image_import'
  |__Atom 'api_image_import-ConfigureStaging-20d240b2-7736-4248-aed7-687fc663b838' {'intention': 'EXECUTE', 'state': 'SUCCESS', 'requires': {}, 'provides': 'file:///var/lib/glance/staging/a767d5ef-5e73-42b5-ae6d-bda2546ee951'}
     |__Flow 'api_image_import'
        |__Atom 'api_image_import_retry' {'intention': 'EXECUTE', 'state': 'SUCCESS', 'requires': {}, 'provides': [(None, {})]}
           |__Flow 'api_image_import': NoSuchOptError: no such option conversion_plugin_options in group [DEFAULT]
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor Traceback (most recent call last):
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/taskflow/engines/action_engine/executor.py", line 53, in _execute_task
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     result = task.execute(**arguments)
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/glance/async/flows/plugins/image_conversion.py", line 78, in execute
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     target_format = CONF.conversion_plugin_options.output_format
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/oslo_config/cfg.py", line 2644, in __getattr__
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     raise NoSuchOptError(name)
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor NoSuchOptError: no such option conversion_plugin_options in group [DEFAULT]
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor


The issue has been documented in upstream bug:
 - https://bugs.launchpad.net/glance/+bug/1805765



Version-Release number of selected component (if applicable):

python-glance-17.0.1-0.20180924181829.afc0ceb.el7ost.noarch
python2-glance-store-0.26.1-1.el7ost.noarch
openstack-glance-17.0.1-0.20180924181829.afc0ceb.el7ost.noarch
puppet-glance-13.3.1-0.20181013130501.8c75648.el7ost.noarch
python2-glanceclient-2.12.1-0.20180809131524.b79154c.el7ost.noarch


How reproducible:
always

Steps to Reproduce:
1. set glance-image-import.conf
~~~
[image_import_opts]
image_import_plugins = ['image_conversion']

[image_conversion]
output_format = raw
~~~

2. Restart glance_api 

3. Attempt to upload image via import

$ glance image-create-via-import --disk-format qcow2 --container-format bare --name conversion_test --import-method web-download --uri https://download.cirros-cloud.net/0.3.5/cirros-0.3.5-x86_64-disk.img

$ glance task-list
+--------------------------------------+------------------+---------+----------------------------------+
| ID                                   | Type             | Status  | Owner                            |
+--------------------------------------+------------------+---------+----------------------------------+
| c5a79f28-2061-4d40-a852-18541da60fb4 | import           | success | 70b6e300a49348989cf86e2f827833b3 |
| 20d240b2-7736-4248-aed7-687fc663b838 | api_image_import | failure | 70b6e300a49348989cf86e2f827833b3 |
+--------------------------------------+------------------+---------+----------------------------------+



2019-03-01 23:43:35.602 26 DEBUG glance.async.taskflow_executor [-] Taskflow executor picked up the execution of task ID 20d240b2-7736-4248-aed7-687fc663b838 of task type api_image_import _run /usr/lib/python2.7/site-packages/glance/async/taskflow_executor.py:157
2019-03-01 23:43:35.625 26 DEBUG glance_store.backend [-] Attempting to import store cinder _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.625 26 DEBUG glance_store.backend [-] Attempting to import store file _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.626 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.cinder.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.626 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.filesystem.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.626 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.http.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.626 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.rbd.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.627 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.sheepdog.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.627 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.swift.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.627 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.vmware_datastore.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.627 26 DEBUG glance_store.backend [-] Attempting to import store http _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.628 26 DEBUG glance_store.backend [-] Attempting to import store no_conf _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.628 26 DEBUG glance_store.backend [-] Attempting to import store rbd _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.628 26 DEBUG glance_store.backend [-] Attempting to import store sheepdog _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.629 26 DEBUG glance_store.backend [-] Attempting to import store swift _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.629 26 DEBUG glance_store.backend [-] Attempting to import store vmware _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.629 26 DEBUG glance_store.backend [-] Registering options for group glance_store register_opts /usr/lib/python2.7/site-packages/glance_store/backend.py:196
2019-03-01 23:43:35.629 26 DEBUG glance_store.backend [-] Registering options for group glance_store register_opts /usr/lib/python2.7/site-packages/glance_store/backend.py:196
2019-03-01 23:43:35.630 26 DEBUG glance_store.backend [-] Attempting to import store file _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.631 26 INFO glance_store._drivers.filesystem [-] Directory to write image files does not exist (/var/lib/glance/staging). Creating.
2019-03-01 23:43:35.631 26 DEBUG glance_store.capabilities [-] Store glance_store._drivers.filesystem.Store doesn't support updating dynamic storage capabilities. Please overwrite 'update_capabilities' method of the store to implement updating logics if needed. update_capabilities /usr/lib/python2.7/site-packages/glance_store/capabilities.py:97
2019-03-01 23:43:35.632 26 DEBUG glance_store.backend [-] Attempting to import store cinder _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.633 26 DEBUG glance_store.backend [-] Attempting to import store file _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.633 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.cinder.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.633 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.filesystem.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.634 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.http.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.634 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.rbd.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.634 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.sheepdog.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.634 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.swift.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.635 26 DEBUG glance_store.backend [-] Attempting to import store glance.store.vmware_datastore.Store _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.635 26 DEBUG glance_store.backend [-] Attempting to import store http _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.635 26 DEBUG glance_store.backend [-] Attempting to import store no_conf _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.635 26 DEBUG glance_store.backend [-] Attempting to import store rbd _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.636 26 DEBUG glance_store.backend [-] Attempting to import store sheepdog _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.636 26 DEBUG glance_store.backend [-] Attempting to import store swift _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.636 26 DEBUG glance_store.backend [-] Attempting to import store vmware _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.636 26 DEBUG glance_store.backend [-] Registering options for group glance_store register_opts /usr/lib/python2.7/site-packages/glance_store/backend.py:196
2019-03-01 23:43:35.637 26 DEBUG glance_store.backend [-] Registering options for group glance_store register_opts /usr/lib/python2.7/site-packages/glance_store/backend.py:196
2019-03-01 23:43:35.637 26 DEBUG glance_store.backend [-] Attempting to import store file _load_store /usr/lib/python2.7/site-packages/glance_store/backend.py:267
2019-03-01 23:43:35.638 26 DEBUG glance_store.capabilities [-] Store glance_store._drivers.filesystem.Store doesn't support updating dynamic storage capabilities. Please overwrite 'update_capabilities' method of the store to implement updating logics if needed. update_capabilities /usr/lib/python2.7/site-packages/glance_store/capabilities.py:97
2019-03-01 23:43:35.714 26 DEBUG glance.async.taskflow_executor [-] Flow 'api_image_import' (d4ed745f-2659-435d-bc22-4bfc97053778) transitioned into state 'RUNNING' from state 'PENDING' _flow_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:145
2019-03-01 23:43:35.719 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-WebDownload-20d240b2-7736-4248-aed7-687fc663b838' (e404eeb7-c213-445f-9bbb-66a8a33c2f7a) transitioned into state 'RUNNING' from state 'PENDING' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:194
2019-03-01 23:43:37.296 26 DEBUG eventlet.wsgi.server [-] (26) accepted ('172.18.1.2', 39012) server /usr/lib/python2.7/site-packages/eventlet/wsgi.py:883
2019-03-01 23:43:37.299 26 INFO eventlet.wsgi.server [-] 172.18.1.2 - - [01/Mar/2019 23:43:37] "GET /healthcheck HTTP/1.0" 200 137 0.002187
2019-03-01 23:43:38.620 26 DEBUG glance_store._drivers.filesystem [-] Wrote 13267968 bytes to /var/lib/glance/staging/a767d5ef-5e73-42b5-ae6d-bda2546ee951 with checksum f8ab98ff5e73ebab884d80c9dc9c7290 and multihash f8ab98ff5e73ebab884d80c9dc9c7290 add /usr/lib/python2.7/site-packages/glance_store/_drivers/filesystem.py:728
2019-03-01 23:43:38.647 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-WebDownload-20d240b2-7736-4248-aed7-687fc663b838' (e404eeb7-c213-445f-9bbb-66a8a33c2f7a) transitioned into state 'SUCCESS' from state 'RUNNING' with result 'file:///var/lib/glance/staging/a767d5ef-5e73-42b5-ae6d-bda2546ee951' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:183
2019-03-01 23:43:38.649 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-ConfigureStaging-20d240b2-7736-4248-aed7-687fc663b838' (ac169be3-4a5b-409a-82a8-a0df7c6472c7) transitioned into state 'RUNNING' from state 'PENDING' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:194
2019-03-01 23:43:38.651 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-ConfigureStaging-20d240b2-7736-4248-aed7-687fc663b838' (ac169be3-4a5b-409a-82a8-a0df7c6472c7) transitioned into state 'SUCCESS' from state 'RUNNING' with result 'file:///var/lib/glance/staging/a767d5ef-5e73-42b5-ae6d-bda2546ee951' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:183
2019-03-01 23:43:38.653 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-Convert_Image-20d240b2-7736-4248-aed7-687fc663b838' (c9b34240-4333-4625-9468-0bf3975d6753) transitioned into state 'RUNNING' from state 'PENDING' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:194
2019-03-01 23:43:38.658 26 WARNING glance.async.taskflow_executor [-] Task 'api_image_import-Convert_Image-20d240b2-7736-4248-aed7-687fc663b838' (c9b34240-4333-4625-9468-0bf3975d6753) transitioned into state 'FAILURE' from state 'RUNNING'
5 predecessors (most recent first):
  Flow 'api_image_import'
  |__Atom 'api_image_import-ConfigureStaging-20d240b2-7736-4248-aed7-687fc663b838' {'intention': 'EXECUTE', 'state': 'SUCCESS', 'requires': {}, 'provides': 'file:///var/lib/glance/staging/a767d5ef-5e73-42b5-ae6d-bda2546ee951'}
     |__Flow 'api_image_import'
        |__Atom 'api_image_import_retry' {'intention': 'EXECUTE', 'state': 'SUCCESS', 'requires': {}, 'provides': [(None, {})]}
           |__Flow 'api_image_import': NoSuchOptError: no such option conversion_plugin_options in group [DEFAULT]
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor Traceback (most recent call last):
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/taskflow/engines/action_engine/executor.py", line 53, in _execute_task
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     result = task.execute(**arguments)
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/glance/async/flows/plugins/image_conversion.py", line 78, in execute
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     target_format = CONF.conversion_plugin_options.output_format
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor   File "/usr/lib/python2.7/site-packages/oslo_config/cfg.py", line 2644, in __getattr__
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor     raise NoSuchOptError(name)
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor NoSuchOptError: no such option conversion_plugin_options in group [DEFAULT]
2019-03-01 23:43:38.658 26 ERROR glance.async.taskflow_executor 
2019-03-01 23:43:38.664 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-Convert_Image-20d240b2-7736-4248-aed7-687fc663b838' (c9b34240-4333-4625-9468-0bf3975d6753) transitioned into state 'REVERTING' from state 'FAILURE' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:194
2019-03-01 23:43:38.664 26 DEBUG glance.async.flows.plugins.image_conversion [-] Image conversion failed. revert /usr/lib/python2.7/site-packages/glance/async/flows/plugins/image_conversion.py:142
2019-03-01 23:43:38.666 26 WARNING glance.async.taskflow_executor [-] Task 'api_image_import-Convert_Image-20d240b2-7736-4248-aed7-687fc663b838' (c9b34240-4333-4625-9468-0bf3975d6753) transitioned into state 'REVERTED' from state 'REVERTING' with result 'None'
2019-03-01 23:43:38.668 26 DEBUG glance.async.taskflow_executor [-] Task 'api_image_import-ConfigureStaging-20d240b2-7736-4248-aed7-687fc663b838' (ac169be3-4a5b-409a-82a8-a0df7c6472c7) transitioned into state 'REVERTING' from state 'SUCCESS' _task_receiver /usr/lib/python2.7/site-packages/taskflow/listeners/logging.py:1



Actual results:

 - Conversion fails

Expected results:

 - Conversion succeeds

 
Additional info:


Note You need to log in before you can comment on or make changes to this bug.